Update German scripts translation
[dpkg.git] / get-version
blobe714be17cf16f8fb9078207ce010403bd4b566ad
1 #!/bin/sh
3 # get-version
5 # Copyright © 2009, 2013-2015, 2018, 2020 Guillem Jover <guillem@debian.org>
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 2 of the License, or
10 # (at your option) any later version.
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with this program. If not, see <https://www.gnu.org/licenses/>.
21 error()
23 echo "get-version: error: $*" 1>&2
24 exit 1
27 if [ -f .dist-version ]; then
28 # Get the version from the file distributed in the tarball.
29 version=$(cat .dist-version)
30 elif [ -d .git ] || [ -f .git ]; then
31 if ! command -v git >/dev/null; then
32 error "cannot get project version, git checkout but git program not found"
35 # Get the version from the git repository. Since tags cannot contain colons
36 # or tildes, we use percent and underscore instead. Reverse that switch here.
37 version=$(git describe --abbrev=4 HEAD 2>/dev/null | tr %_ :~)
39 # Check if we are on a dirty checkout.
40 git update-index --refresh -q >/dev/null
41 dirty=$(git diff-index --name-only HEAD 2>/dev/null)
42 if [ -n "$dirty" ]; then
43 version="$version-dirty"
45 else
46 error "cannot get project version, not a git checkout nor a distribution tarball."
49 # Use printf to avoid the trailing new line that m4_esyscmd would not handle.
50 printf "%s" "$version"